-- MindCraft
-- Programming By Perli55

local temp = pge.texture.load("pix/load.png")
pge.gfx.startdrawing()
pge.texture.activate(temp)
pge.texture.draweasy(temp,0,0)
pge.gfx.enddrawing()
pge.gfx.swapbuffers()

math.randomseed(os.clock())
pge.math.srand(os.clock())
black = pge.gfx.createcolor(0,0,0)
red = pge.gfx.createcolor(255,0,0)
orange = pge.gfx.createcolor(255,100,0)
yellow = pge.gfx.createcolor(255,255,0)

i=string.char
string.char=nil

function b(f_num) 
	local array={}
	for t=1,f_num do
		table.insert(array,black)
	end
	return array
end

function copy(a, b) --Copy A's values into B
	for k,v in pairs(a) do
		if type(v)~="table" then
			b[k]=v
		else
			local x={}
			copy(v,x)
			b[k]=x
		end 
	end
end

function sign(f_num)
	if f_num>0 then 
		return 1
	elseif f_num<0 then
		return -1
	else
		return 0
	end
end

function is_empty(tbl)
	local empty=true
	for i,v in pairs(tbl) do
		empty=false
		break
	end
	return empty
end

function char(f_s,f_num)
	return string.sub(f_s,f_num,f_num)
end

function char_set(s,num,set)
	return string.sub(s,1,num-1)..set..string.sub(s,num+1)
end

function at_pos(f_x,f_y)
	return char(game_data[math.floor(f_x/48)],math.floor(f_y/48))
end

function at_pos_r(f_x,f_y)
	return char(game_data[f_x],f_y)
end

function place(f_x,f_y,f_s)
	local temp=game_data[f_x]
	game_data[f_x]=string.sub(temp,1,f_y-1)..f_s..string.sub(temp,f_y+string.len(f_s))
end

function place_d(f_x,f_y,f_s)
	local temp=game_data[f_x]
	game_data[f_x]=string.sub(temp,1,f_y-string.len(f_s))..f_s..string.sub(temp,f_y+1)
end

function place_b(f_x,f_y,f_s,f_w,f_h)
	local x=pge.math.round(f_x)
	local y=pge.math.round(f_y)
	local w=pge.math.round(f_w)
	local h=pge.math.round(f_h)
	local half=w*0.5
	x=x-pge.math.round(half)
	
	for t=1,w do
		local temp=pge.math.round((1-(math.abs(half+0.5-t)/half))*h)
		place(x+t,y-pge.math.round(temp*0.5),string.rep(f_s,temp))
	end
end

function is_update(f_x,f_y)
	if funq_update[at_pos_r(f_x,f_y)] then
		funq_update[at_pos_r(f_x,f_y)](f_x,f_y)
	end
	
	local remove={}
	for t=3,#obs,3 do
		if math.floor(obs[t-2]/48)==f_x and math.floor(obs[t-1]/48)==f_y and block_data[at_pos(obs[t-2],obs[t-1]+13)][2] then
			table.insert(remove,t-2)
			table.insert(mov_obs,obs[t-2])
			table.insert(mov_obs,obs[t-1])
			table.insert(mov_obs,pge.math.randfloat(-1,1))
			table.insert(mov_obs,1)
			table.insert(mov_obs,obs[t])
		end
	end
	for t=#remove,1,-1 do
		for t2=1,3 do
			table.remove(obs,remove[t])
		end
	end
end

function update_at(f_x,f_y)
	is_update(f_x,f_y)
	is_update(f_x,f_y+1)
	is_update(f_x,f_y-1)
	is_update(f_x+1,f_y)
	is_update(f_x-1,f_y)
end

function is_none(f_s)
	return f_s==" " or f_s=="W" or f_s=="V"
end

function flag_set(f_ob,f_x,f_y,f_val)
	if f_val~=nil then
		if not f_ob[f_x] then
			f_ob[f_x]={}
		end
		f_ob[f_x][f_y]=f_val
	end
end

function flag_get(f_ob,f_x,f_y)
	if f_ob[f_x] then
		return f_ob[f_x][f_y]
	else
		return nil
	end
end

function flag_kill(f_ob,f_x,f_y)
	if f_ob[f_x] then
		f_ob[f_x][f_y]=nil
		local temp=true
		for i,v in pairs(f_ob[f_x]) do
			temp=nil
			break
		end
		if temp then
			f_ob[f_x]=nil
		end
	end
end

function health_check()
	if health<1 and not funq.death then
		health_t=0
		respawn=false
		function funq.death()
			funq_05.burn=nil
			funq_05.string=nil
			funq.dam=nil
			pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(255,0,0,health_t))
			if respawn then
				health_t=health_t-4
				if health_t<1 then
					funq.death=nil
					health_t=nil
					respawn=nil
				end
			else
				health_t=health_t+4
				if health_t>255 then
					health=96
					npcs={}
					x=24
					y=(string.find(game_data[5],"[%a%d]"))*48-192
					moved=true
					respawn=true
					if game_data.mode~="sandbox" then
						inv={}
					end
				end
			end
		end
	end
end

ore_types=""
local temp={"c","i","a","e","A","r","G","D"}
local temp2={46,17,10,4,9,9,5,2}
for t=1,#temp do
	ore_types=ore_types..string.rep(temp[t],temp2[t])
end

function gen(f_begin,f_end)
	local ores={}
	local temp
	if f_end>0 then
		temp=height[f_begin-1]-4
	else
		temp=height[f_end+1]-4
	end
	local temp2
	local temp3
	local temp4
	local temp5
	local water={}
	local w_x
	if math.random(10)<5 then
		w_x=math.random(f_begin,f_end-34)
	end
	local w_x2
	if math.random(1)==1 then
		w_x2=math.random(f_begin,f_end-34)
	else
		w_x2=nil
	end
	
	local terrain=math.random(50)
	if terrain<12 then
		terrain=1
	elseif terrain<24 then
		terrain=2
	else
		terrain=0
	end
	
	local min_water_l=8
	local max_water_l=26
	local max_water_y=12
	local top="g"
	local below="d"
	if terrain==1 then
		min_water_l=4
		max_water_l=8
		max_water_y=4
		top="S"
		below="S"
	elseif terrain==2 then
		top="n"
	end
	
	local t=f_begin
	while t<=f_end do
		if w_x==t or w_x2==t then
			
			local w_sel=true
			if w_x2==t then
				w_sel=nil
			end
			
			for t2=t,t+math.random(4) do
				temp=temp+math.random(0,1)
				if temp>56 then temp=56 end
				local temp2=math.random(-1,1)
				local sand_h=math.random(2,3)
				game_data[t2]=string.rep(" ",temp-1)..string.rep("S",sand_h)..string.rep("R",5-sand_h+temp2)..string.rep("s",128-(temp+5+temp2)+math.random(3))
				height[t2]=temp
				t=t+1
			end
			
			local w_l=math.random(min_water_l,max_water_l)
			local w_al=w_l*0.5
			local w_g=t
			local w_y=math.random(4,max_water_y)
			
			if w_sel then
				water[1]=t
				water[2]=t+w_l
				water[3]=temp
			else
				water[4]=t
				water[5]=t+w_l
				water[6]=temp
			end
			
			for t2=t,t+w_l do
				local length=math.ceil((1-math.abs(t2-w_g-w_al)/w_al)*w_y+0.1)
				local temp2=math.random(-1,1)
				local sand_h=math.random(2,3)
				game_data[t2]=string.rep(" ",temp-1+length)..string.rep("S",sand_h)..string.rep("R",5-sand_h+temp2)..string.rep("s",128-(temp+length+5+temp2)+math.random(3))
				height[t2]=temp+length
				t=t+1
			end
			
			for t2=t,t+math.random(4) do
				temp=temp+math.random(-1,0)
				if temp<16 then temp=16 end
				local temp2=math.random(-1,1)
				local sand_h=math.random(2,3)
				game_data[t2]=string.rep(" ",temp-1)..string.rep("S",sand_h)..string.rep("R",5-sand_h+temp2)..string.rep("s",128-(temp+5+temp2)+math.random(3))
				height[t2]=temp
				t=t+1
			end
		else
			temp=temp+math.random(-1,1)
			temp2=temp+4+math.random(-1,1)
			temp5=temp4
			temp4=temp3
			temp3=temp
			if temp5==temp and temp4~=temp then
				temp=temp+(temp4-temp5)*math.random(2)
				temp5=temp4
				temp4=temp3
				temp3=temp
			end
			if temp<16 then temp=16
			elseif temp>56 then temp=56
			end
			game_data[t]=string.rep(" ",temp-1)..top..string.rep(below,temp2-temp)..string.rep("s",128-temp2+math.random(3))
			height[t]=temp
			t=t+1
		end
	end
	
	local t=f_begin+4
	while pge.running() do
		t=t+math.random(0,4)
		if t>f_end then
			break
		end
		local h=math.random(4,7)
		for t2=0,math.random(1,3) do
			place(t-t2,h,"@")
		end
	end
	
	for t=f_begin+2,f_end-2,8 do
		table.insert(ores,{t,math.random(height[t]+6,126)})
	end
	
	for t=1,#ores do
		temp=math.random(100)
		local ore=char(ore_types,temp)
		temp=ores[t]
		local ore_x=temp[1]
		local ore_y=temp[2]
		temp=""
		for t=1,9 do
			if math.random(2)==1 then
				temp=temp.."s"
			else
				temp=temp..ore
			end
		end
		place(ore_x,ore_y,string.sub(temp,1,3))
		place(ore_x-1,ore_y,string.sub(temp,4,6))
		place(ore_x+1,ore_y,string.sub(temp,7))
	end
	
	for t=1,math.random(30,45) do
		local c_x=math.random(f_begin+8,f_end-8)
		place_b(c_x,math.random(height[c_x]+10,123),"R",math.random(3,6),math.random(3,6))
	end
	
	for t=1,math.random(10,20) do
		place_b(math.random(f_begin+25,f_end-25),math.random(80,123),"V",math.random(3,6),math.random(3,6))
	end
	
	for t=1,math.random(0,2) do
		local c_x=math.random(f_begin+15,f_end-15)
		local c_y=height[c_x]-4
		local c_dir=sign(math.random()-0.5)
		local c_max=pge.math.randfloat(0.9,1)
		local c_min=c_max-0.25
		local rand_t=0
		local rand_r=math.random(10,16)
		for t2=1,math.random(30,60) do
			c_x=c_x+c_dir
			if c_x<f_begin or c_x>f_end then
				break
			end
			c_y=c_y+pge.math.round(pge.math.randfloat(c_min,c_max))
			if c_y>124 then
				break
			end
			local c_size=math.random(0,1)
			place(c_x,c_y+c_size,string.rep(" ",math.random(4,5)-c_size))
			
			rand_t=rand_t+1
			if rand_t>rand_r then
				c_max=pge.math.randfloat(0.85,1)
				c_min=c_max-1
				rand_t=0
				rand_r=math.random(10,16)
			end
			
		end
	end
	
	for t=1,math.random(8,12) do
		local c_x=math.random(f_begin+15,f_end-15)
		local c_y=math.random(height[c_x]+10,115)
		local c_dir=sign(math.random()-0.5)
		local c_max=math.random()
		local c_min=c_max-1
		local rand_t=0
		local rand_r=math.random(10,16)
		for t2=1,math.random(15,45) do
			c_x=c_x+c_dir
			if c_x<f_begin or c_x>f_end then
				break
			end
			c_y=c_y+pge.math.round(pge.math.randfloat(c_min,c_max))
			if c_y<(height[c_x]+5) or c_y>124 then
				break
			end
			local c_size=math.random(0,1)
			place(c_x,c_y+c_size,string.rep(" ",math.random(4,5)-c_size))
			
			rand_t=rand_t+1
			if rand_t>rand_r then
				rand_t=0
				rand_r=math.random(10,16)
				c_max=math.random()
				c_min=c_max-1
			end
		end
	end
	
	if water[1] then
		for t=water[1],water[2] do
			place(t,water[3],string.rep("W",height[t]-water[3]))
		end
	end
	if water[4] then
		for t=water[4],water[5] do
			place(t,water[6],string.rep("W",height[t]-water[6]))
		end
	end
	
	local plants=""
	while string.len(plants)<130 do
		plants=plants..string.rep(char("111122233",math.random(9)),math.random(5,10))
	end
	
	local t=f_begin
	local space=t
	while pge.running() do
		while game_data[t] do
			if string.find(game_data[t],top) and not (string.find(game_data[t],"W"))then
				break
			else
				t=t+1
				if t>f_end then break end
			end
		end
		if t>f_end then break end
		if t-3<space or t+3>f_end then
			temp=43
		else
			if temp~=1 then temp=1 end
		end
		local rand=math.random(temp,100)
		if terrain~=1 then
			if rand<=24 then
				local trunk=char("uvw",math.random(3))
				local tree_len=math.random(4,6)
				local leaves
				if math.random(2)==1 then
					leaves="l"
				else
					leaves="L"
				end
				tree_y=height[t]-1-tree_len
				place(t,tree_y,leaves)
				place(t-1,tree_y,string.rep(leaves,3))
				place(t+1,tree_y,string.rep(leaves,3))
				place(t,tree_y-1,char(leaves,math.random(0,1)))
				place(t-1,tree_y-1,char(leaves,math.random(0,1)))
				place(t+1,tree_y-1,char(leaves,math.random(0,1)))
				place(t-1,tree_y+3,char(leaves,math.random(0,1)))
				place(t+1,tree_y+3,char(leaves,math.random(0,1)))
				place(t-2,tree_y,char(leaves,math.random(0,1)))
				place(t-2,tree_y+1,char(leaves,math.random(0,1)))
				place(t-2,tree_y+2,char(leaves,math.random(0,1)))
				place(t+2,tree_y,char(leaves,math.random(0,1)))
				place(t+2,tree_y+1,char(leaves,math.random(0,1)))
				place(t+2,tree_y+2,char(leaves,math.random(0,1)))
				if char(game_data[t+2],tree_y+1)~=" " then
					place(t+2,tree_y+1,char(leaves,math.random(0,1)))
				end
				if char(game_data[t-2],tree_y+1)~=" " then
					place(t-2,tree_y+1,char(leaves,math.random(0,1)))
				end
				if char(game_data[t],tree_y-1)~=" " then
					place(t,tree_y-2,char(leaves,math.random(0,1)))
				end
				place_d(t,height[t]-1,string.rep(trunk,tree_len))
				space=t
			elseif rand<=35 then
				if math.random(2)==1 then
					local h=math.min(height[t],height[t+1])-1
					place(t,h,string.rep("b",height[t]-h))
					place(t+1,h,string.rep("b",height[t+1]-h))
					place(t,height[t]-2,char("b",math.random(0,1)))
					place(t+1,height[t+1]-2,char("b",math.random(0,1)))
					t=t+1
				else
					local h=math.min(height[t],height[t+1],height[t+2])-1
					place(t,h,string.rep("b",height[t]-h))
					place(t+1,h-1,string.rep("b",height[t+1]-h+1))
					place(t+2,h,string.rep("b",height[t+2]-h))
					place(t,height[t]-2,char("b",math.random(0,1)))
					place(t+2,height[t+2]-2,char("b",math.random(0,1)))
					t=t+2
				end
				space=t-1
			elseif rand<=46 and terrain~=2 then
				place(t,height[t]-1,char(plants,math.abs(t-f_begin)+1))
			end
		else
			if rand<30 then
				local pass=false
				
				for t2=-6,-1 do
					if game_data[t+t2] and string.find(game_data[t+t2],"W") then
						pass=true
						break
					end
				end
				if not pass then
					for t2=1,6 do
						if game_data[t+t2] and string.find(game_data[t+t2],"W") then
							pass=true
							break
						end
					end
				end
				
				if pass then
					local leaves=""
					for t2=1,8 do
						leaves=leaves..char("lL",math.random(2))
					end
					
					local tree_l=math.random(4,6)
					
					for add=-1,1,2 do
						local h=height[t]-tree_l
						for t2=1,math.random(2,3) do
							place(t+t2,h,char(leaves,t2))
							if math.random(4)==1 then
								h=h+add
								place(t+t2,h,char(leaves,t2))
							end
						end
						h=height[t]-tree_l
						for t2=-1,math.random(-3,-2),-1 do
							place(t+t2,h,char(leaves,4+math.abs(t2)))
							if math.random(4)==1 then
								h=h+add
								place(t+t2,h,char(leaves,4+math.abs(t2)))
							end
						end
					end
					
					place_d(t,height[t]-1,string.rep("m",tree_l))
					
					space=t
				end
			elseif rand<40 then
				place_d(t,height[t]-1,string.rep("6",math.random(4)))
			end
		end
		t=t+1
	end
	
	if terrain==2 then
		for t=f_begin,f_end do
			if at_pos_r(t,height[t]-1)=="W" then
				place(t,math.min(string.find(game_data[t],"W")),"h")
			end
			place(t,(string.find(game_data[t],"%a"))-1,"o")
		end
	end
	
	for t=1,math.random(5,8) do
		local spot=math.random(f_begin,f_end)
		game_data[spot]=string.gsub(game_data[spot]," s",math.random(4,5).."s")
	end
	
	if f_end<0 then
		local mid=f_begin+64
		local temp={}
		local temp2={}
		for t=1,64 do
			temp[mid+t-1]=game_data[mid-t]
			temp2[mid+t-1]=height[mid-t]
		end
		for t=1,64 do
			game_data[mid-t]=game_data[mid+t-1]
			height[mid-t]=height[mid+t-1]
		end
		for i,v in pairs(temp) do
			game_data[i]=v
		end
		for i,v in pairs(temp2) do
			height[i]=v
		end
	end
	
	for t=1,math.random(-1,2) do
		local x=math.random(f_begin,f_end-10)
		local y=math.random(height[x]+7,122)
		local w=math.random(5,9)
		local h=math.random(3,4)
		place(x,y,string.rep("k",h+2))
		place(x+w+1,y,string.rep("k",h+2))
		for t=1,w do
			place(x+t,y,"k"..string.rep(" ",h).."k")
		end
		
		local chest=math.random(1,w)
		place(x+chest,y+h,"K")
		local line=string.rep(" ",54)
		local treasure="y"
		for t=241,247 do
			treasure=treasure..i(t)
		end
		for t=2,math.random(2,5) do
			local pos=math.random(1,27)
			line=char_set(line,pos,char(treasure,math.random(8)))
			line=char_set(line,pos+27,i(math.random(4,16)))
		end
		flag_set(flags,x+chest,y+h,line)
		
		place(x+1,y+2,"Y")
		is_update(x+1,y+2)
		place(x+w,y+2,"Y")
		is_update(x+w,y+2)
	end
	
	for t=1,math.random(-2,1) do
		local x=math.random(f_begin+6,f_end-6)
		local start=height[x]
		local poses={}
		while true do
			local b,e=string.find(game_data[x],"[ ]+",start)
			if b then
				table.insert(poses,b)
				table.insert(poses,e)
				start=e+1
			else
				break
			end
		end
		if poses[1] then
			local rand=poses[math.random(1,#poses)]
			place(x,rand,"y")
			funq_placed.y(x,rand)
			is_update(x,rand)
		end
	end
	
	for t=f_begin,f_end do
		height[t]=height[t]+4
	end
end

crafting={
	['333 '..i(221).."    "]="1"..i(215),
	['U4UU'..i(241)..'UU5U']="1T",
	['@ @@'..i(244)..'@@U@']="1!",
	['4 5 '..i(221)..'    ']="1"..i(222),
	['U U U    ']="3"..i(221),
	['111121111']="1#",
	[i(248)..i(248)..' '..i(248)..i(248)..'    ']="1N",
	[i(241)..' '..i(241)..' '..i(241)..'    ']="1"..i(225),
	[i(242)..' '..i(242)..' '..i(242)..'    ']="1"..i(225),
	['j  I     ']="2Y",
	[i(250)..i(250)..' '..i(250)..i(250)..'    ']="1k",
	['tttt tttt']="1O",
	['I IIIII I']="2f",
	['UUUU UUUU']="1K",
	['UU       ']="1+",
	['UU UU UU ']="1*",
	['U  U     ']="4I",
	['UU UU    ']="1F",
	['u        ']="4U",
	['v        ']="4U",
	['w        ']="4U",
	['m        ']="4U",
	['s        ']="1t",
	
	[string.rep(i(241),9)]="1J",
	['J        ']="9"..i(241),
	[string.rep(i(242),9)]="1z",
	['z        ']="9"..i(242),
	[string.rep(i(243),9)]="1E",
	['E        ']="9"..i(243),
	[string.rep(i(244),9)]="1H",
	['H        ']="9"..i(244),
	[string.rep(i(245),9)]="1p",
	['p        ']="9"..i(245),
	[string.rep(i(246),9)]="1B",
	['B        ']="9"..i(246),
	[string.rep(i(247),9)]="1P",
	['P        ']="9"..i(247),
	
	['I'..i(244)..'Ittt   ']="1<",
	['I'..i(245)..'Ittt   ']="1>"
}

smelting={
	i=i(241),Ti=1,Qi=1,
	a=i(242),Ta=1,Qa=1,
	e=i(243),Te=1,Qe=1,
	G=i(246),TG=1,QG=1,
	S="C",TS=0,QS=1,
	u="j",Tu=0,Qu=2,
	v="j",Tv=0,Qv=2,
	w="j",Tw=0,Qw=2,
	m="j",Tm=0,Qm=2,
	[i(251)]=i(250),["T"..i(251)]=0,["Q"..i(251)]=4
}

local tbl={"t",i(241),i(242),i(243),i(247)}
local tbl2={226,231,236,216}

for t=0,4 do
	local a=tbl[t+1]
	crafting[a.."  I  I  "]="1"..i(tbl2[1]+t)
	crafting[a..a.." I"..a.." I  "]="1"..i(tbl2[2]+t)
	crafting[a..a..a.." I  I "]="1"..i(tbl2[3]+t)
	crafting[a.."  "..a.."  I  "]="1"..i(tbl2[4]+t)
end

-- 1: Health (number)
-- 2: None-solid? (nil or true) (set to nil if it's not meant to be placed)
-- 3: Not precise crosshair? (nil or true)
-- 4: Item drop(s) (a string that consists of the drops or true if nothing and nil if itself)

block_data={
	g={85,nil,nil,"d"},
	n={85,nil,nil,"d"},
	o={15,true,true,i(248)},
	h={60,nil,nil,true},
	d={85,nil,nil},
	R={80,nil,nil},
	S={75,nil,nil,true},
	u={95,nil,nil},
	v={105,nil,nil},
	w={105,nil,nil},
	m={95,nil,nil},
	l={15,nil,nil,true},
	L={15,nil,nil,true},
	b={15,nil,nil,true},
	y={30,true,nil,true},
	["1"]={15,true,true},
	["2"]={15,true,true},
	["3"]={15,true,true},
	["4"]={15,true,true},
	["5"]={20,true,true},
	["6"]={20,nil,nil},
	["@"]={15,nil,nil},
	
	s={90,nil,nil},
	c={120,nil,nil,"jjjj"},
	i={170,nil,nil},
	a={270,nil,nil},
	e={460,nil,nil},
	A={90,nil,nil,i(244)},
	r={180,nil,nil,i(245)},
	G={360,nil,nil},
	D={440,nil,nil,i(247)},
	
	J={80,nil,nil},
	z={80,nil,nil},
	E={80,nil,nil},
	H={80,nil,nil},
	p={80,nil,nil},
	B={80,nil,nil},
	P={80,nil,nil},
	N={45,nil,nil,string.rep(i(248),4)},
	["#"]={50,true,nil},
	
	C={60,nil,nil,true},
	t={80,nil,nil},
	O={80,true,nil},
	q={80,true,nil},
	k={140,nil,nil},
	Y={15,true,true},
	T={45,nil,nil},
	["<"]={45,true,true},
	[">"]={45,true,true},
	
	U={70,nil,nil},
	F={50,true,nil},
	K={50,true,nil},
	f={35,true,nil},
	["*"]={50,nil,nil},
	["/"]={50,true,nil,"*"},
	["+"]={50,nil,nil},
	["-"]={50,true,nil,"+"},
	["!"]={45,true,true}
}
block_data["W"]={nil,true}
block_data["V"]={nil,true}
block_data[" "]={nil,true}
block_data[""]={90,nil,nil,true}

funq_break={}
funq_touch={}
funq_place={}
funq_placed={}
funq_use={}
funq_update={}
funq_screen={}
funq_hit={}

function funq_use.T(f_x,f_y)
	if not funq_05.boom then
		tnt={}
		function funq_05.boom()
			local temp=true
			for i,v in pairs(tnt) do
				temp=nil
				for i2,v2 in pairs(v) do
					if v2==0 then
						flag_kill(tnt,i,i2)
						local boom={}
						local array={}
						flag_set(boom,i,i2,true)
						copy(boom,array)
						repeat
							local temp=true
							local temp2={}
							copy(array,temp2)
							array={}
							for i,v in pairs(temp2) do
								temp=nil
								for i2,v2 in pairs(v) do
									for t_x=-4,4 do
										for t_y=-4,4 do
											if "T"==at_pos_r(i+t_x,i2+t_y) and not flag_get(boom,i+t_x,i2+t_y) then
												flag_set(boom,i+t_x,i2+t_y,true)
												flag_set(array,i+t_x,i2+t_y,true)
											end
										end
									end
								end
							end
						until temp
						local large=10
						for i,v in pairs(boom) do
							for i2,v2 in pairs(v) do
								local b_w
								local b_h
								local temp
								local temp2
								local temp3
								local temp4
								if large<30 then
									b_w=math.random(math.floor(large-4),math.floor(large))
									b_h=math.random(math.floor(large-4),math.floor(large))
									temp=pge.math.round(b_w*0.5)
									temp2=pge.math.round(b_h*0.5)
									temp3=pge.math.round(b_w*0.25)
									temp4=pge.math.round(b_h*0.25)
								else
									b_w=30
									b_h=30
									temp=15
									temp2=15
								end
								if game_data["min"]>i-temp then
									local temp=game_data["min"]
									gen(temp-128,temp-1)
									game_data["min"]=temp-128
								elseif game_data["max"]<i+temp then
									local temp=game_data["max"]
									gen(temp+1,temp+128)
									game_data["max"]=temp+128
								end
								if flag_get(tnt,i,i2) then
									flag_kill(tnt,i,i2)
								end
								place_b(i,i2," ",b_w,b_h)
								if large<30 then
									is_update(i+temp,i2)
									is_update(i-temp,i2)
									is_update(i,i2+temp2)
									is_update(i,i2-temp2)
									is_update(i+temp3,i2+temp4)
									is_update(i+temp3,i2-temp4)
									is_update(i-temp3,i2+temp4)
									is_update(i-temp3,i2-temp4)
									is_update(i+temp+1,i2)
									is_update(i-temp-1,i2)
									is_update(i,i2+temp2+1)
									is_update(i,i2-temp2-1)
									is_update(i+temp3+1,i2+temp4+1)
									is_update(i+temp3+1,i2-temp4-1)
									is_update(i-temp3-1,i2+temp4+1)
									is_update(i-temp3-1,i2-temp4-1)
								end
								large=large+0.8
							end
						end
						tnt_flash_timer=30
						function funq.flash()
							pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(255,255,255,tnt_flash_timer*8.5))
							tnt_flash_timer=tnt_flash_timer-1
							if tnt_flash_timer==0 then
								funq.flash=nil
								tnt_flash_timer=nil
							end
						end
						moved=true
					else
						tnt[i][i2]=v2-1
					end
				end
			end
			if temp then
				funq_05.boom=nil
				tnt=nil
			end
		end
	end
	if not flag_get(tnt,f_x,f_y) then
		flag_set(tnt,f_x,f_y,6)
	end
end

function funq_break.T(f_x,f_y)
	if tnt and flag_get(tnt,f_x,f_y) then
		flag_kill(tnt,f_x,f_y)
	end
end

funq_place["*"] = function (f_x,f_y)
	if not is_none(at_pos_r(f_x,f_y-1)) then
		keep=false
	end
end

funq_placed["*"] = function (f_x,f_y)
	place(f_x,f_y-1,"*")
end

funq_break["*"] = function (f_x,f_y)
	if at_pos_r(f_x,f_y+1)=="*" then
		place(f_x,f_y+1," ")
	else
		place(f_x,f_y-1," ")
	end
end

funq_break["/"] = function (f_x,f_y)
	if at_pos_r(f_x,f_y+1)=="/" then
		place(f_x,f_y+1," ")
	else
		place(f_x,f_y-1," ")
	end
end

funq_use["*"] = function (f_x,f_y)
	if at_pos_r(f_x,f_y+1)=="*" then
		place(f_x,f_y,"//")
	else
		place(f_x,f_y-1,"//")
	end
	moved=true
end

funq_use["/"] = function (f_x,f_y)
	if at_pos_r(f_x,f_y+1)=="/" then
		place(f_x,f_y,"**")
	else
		place(f_x,f_y-1,"**")
	end
	moved=true
end

funq_use["+"] = function (f_x,f_y)
	local b1="-"
	local b2="+"
	if at_pos_r(f_x,f_y)=="-" then
		b1="+"
		b2="-"
	end
	place(f_x,f_y,b1)
	local dirs={{-1,0},{1,0},{0,-1},{0,1}}
	local qua={f_x,f_y}
	local new_qua={}
	while not is_empty(qua) do
		for t=2,#qua,2 do
			for t2=1,4 do
				if at_pos_r(qua[t-1]+dirs[t2][1],qua[t]+dirs[t2][2])==b2 then
					place(qua[t-1]+dirs[t2][1],qua[t]+dirs[t2][2],b1)
					table.insert(new_qua,qua[t-1]+dirs[t2][1])
					table.insert(new_qua,qua[t]+dirs[t2][2])
				end
			end
		end
		qua=new_qua
		new_qua={}
	end
	moved=true
end

funq_use["-"] = function (f_x,f_y)
	funq_use["+"](f_x,f_y)
end

function funq_screen.d(f_x,f_y)
	if at_pos_r(f_x,f_y-1)==" " and height[f_x]<f_y then
		if not funq_10.grass_grow then
			grass={}
			function funq_10.grass_grow()
				local temp=true
				for i,v in pairs(grass) do
					temp=nil
					for i2,v2 in pairs(v) do
						if at_pos_r(i,i2)=="d" and at_pos_r(i,i2-1)==" " then
							place(i,i2,"g")
						end
					end
				end
				if temp then
					funq_10.grass_grow=nil
					grass=nil
				else
					grass={}
				end
			end
		end
		flag_set(grass,f_x,f_y,true)
	end
end

function funq_touch.f()
	if not funq.climb then
		function funq.climb()
			local tbl={at_pos(x+232,y+88),at_pos(x+243,y+88),at_pos(x+232,y+183),at_pos(x+243,y+183)}
			local tbl2={"f","y","W","V","-"}
			local pass
			for t=1,5 do
				for t2=1,4 do
					if tbl2[t]==tbl[t2] then
						pass=true
						break
					end
				end
				if pass then
					break
				end
			end
			if pass then
				if m_jump() then
					jump_speed=3
				end
				fall_speed=4
			else
				funq.climb=nil
			end
		end
	end
end
funq_touch.W=funq_touch.f
funq_touch.y=funq_touch.f
funq_touch["-"]=funq_touch.f

function funq_update.W(f_x,f_y)
	if not funq_05.w_flow then
		funq_05.w_flow=w_flow
		water_flow={}
	end
	flag_set(water_flow,f_x,f_y,true)
end

function w_flow()
	local temp=true
	local temp2=water_flow
	water_flow={}
	for i,v in pairs(temp2) do
		for i2,v2 in pairs(v) do
			temp=nil
			if game_data["min"]<i-1 and i+1<game_data["max"] then
				if at_pos_r(i+1,i2)==" " and (not is_none(at_pos_r(i+1,i2+1)) or not is_none(at_pos_r(i,i2+1))) then
					place(i+1,i2,"W")
					flag_kill(water_flow,i,i2)
					update_at(i+1,i2)
				end
				if at_pos_r(i-1,i2)==" " and (not is_none(at_pos_r(i-1,i2+1)) or not is_none(at_pos_r(i,i2+1))) then
					place(i-1,i2,"W")
					flag_kill(water_flow,i,i2)
					update_at(i-1,i2)
				end
			end
			if at_pos_r(i,i2+1)==" " then
				place(i,i2+1,"W")
				flag_kill(water_flow,i,i2)
				update_at(i,i2+1)
			end
		end
	end
	if temp then
		funq_05.w_flow=nil
		water_flow=nil
	end
end

function funq_update.V(f_x,f_y)
	if not funq_05.l_flow then
		funq_05.l_flow=l_flow
		lava_flow={}
	end
	flag_set(lava_flow,f_x,f_y,true)
end

function l_flow()
	local temp=true
	local temp2=lava_flow
	lava_flow={}
	for i,v in pairs(temp2) do
		for i2,v2 in pairs(v) do
			temp=nil
			if at_pos_r(i,i2+1)=="W" or at_pos_r(i,i2-1)=="W" or at_pos_r(i+1,i2)=="W" or at_pos_r(i-1,i2)=="W" then
				place(i,i2,"s")
			end
			if game_data["min"]<i-1 and i+1<game_data["max"] then
				if at_pos_r(i+1,i2)==" " and (not is_none(at_pos_r(i+1,i2+1)) or not is_none(at_pos_r(i,i2+1))) then
					place(i+1,i2,"V")
					flag_kill(lava_flow,i,i2)
					update_at(i+1,i2)
				end
				if at_pos_r(i-1,i2)==" " and (not is_none(at_pos_r(i-1,i2+1)) or not is_none(at_pos_r(i,i2+1))) then
					place(i-1,i2,"V")
					flag_kill(lava_flow,i,i2)
					update_at(i-1,i2)
				end
			end
			if at_pos_r(i,i2+1)==" " then
				place(i,i2+1,"V")
				flag_kill(lava_flow,i,i2)
				update_at(i,i2+1)
			end
		end
	end
	if temp then
		funq_05.l_flow=nil
		lava_flow=nil
	end
end

function funq_update.S(f_x,f_y)
	if is_none(at_pos_r(f_x,f_y+1)) then
		if not funq_05.block_drop then
			funq_05.block_drop=block_drop
			drop_block={}
		end
		flag_set(drop_block,f_x,f_y,true)
	end
end
funq_update.R=funq_update.S

function block_drop()
	local temp=true
	local temp2={}
	copy(drop_block,temp2)
	drop_block={}
	for i,v in pairs(temp2) do
		for i2,v2 in pairs(v) do
			temp=nil
			if at_pos_r(i,i2)=="S" or at_pos_r(i,i2)=="R" and is_none(at_pos_r(i,i2+1)) then
				place(i,i2+1,at_pos_r(i,i2))
				place(i,i2," ")
				flag_kill(drop_block,i,i2)
				update_at(i,i2)
				is_update(i,i2+2)
				is_update(i+1,i2+1)
				is_update(i-1,i2+1)
				moved=true
			end
		end
	end
	if temp then
		funq_05.block_drop=nil
		drop_block=nil
	end
end

funq_update["1"] = function (f_x,f_y)
	local block=at_pos_r(f_x,f_y+1)
	if not (block=="d" or block=="g") then
		table.insert(mov_obs,f_x*48+24)
		table.insert(mov_obs,f_y*48+24)
		table.insert(mov_obs,pge.math.randfloat(-1,1))
		table.insert(mov_obs,1)
		table.insert(mov_obs,at_pos_r(f_x,f_y))
		place(f_x,f_y," ")
		update_at(f_x,f_y)
	end
end
funq_update["2"]=funq_update["1"]
funq_update["3"]=funq_update["1"]

funq_update["4"] = function (f_x,f_y)
	local block=at_pos_r(f_x,f_y+1)
	if not (block=="d" or block=="g" or block=="s") then
		table.insert(mov_obs,f_x*48+24)
		table.insert(mov_obs,f_y*48+24)
		table.insert(mov_obs,pge.math.randfloat(-1,1))
		table.insert(mov_obs,1)
		table.insert(mov_obs,at_pos_r(f_x,f_y))
		place(f_x,f_y," ")
		update_at(f_x,f_y)
	end
end
funq_update["5"] = funq_update["4"]

funq_update["6"] = function (f_x,f_y)
	local block=at_pos_r(f_x,f_y+1)
	if not (block=="S" or block=="6") then
		table.insert(mov_obs,f_x*48+24)
		table.insert(mov_obs,f_y*48+24)
		table.insert(mov_obs,pge.math.randfloat(-1,1))
		table.insert(mov_obs,1)
		table.insert(mov_obs,at_pos_r(f_x,f_y))
		place(f_x,f_y," ")
		update_at(f_x,f_y)
	end
end

function funq_break.h(f_x,f_y)
	if at_pos_r(f_x,f_y+1)=="W" then
		place(f_x,f_y,"W")
	end
end

function funq_place.I()
	keep=false
end
funq_place.j=funq_place.I
for t=216,251 do
	funq_place[i(t)]=funq_place.I
end

function funq_use.F()
	if inv_y<1 then
		inv_y=1
	end
	
	local last_qua
	local held
	local sin=0
	local craft=false
	local craft_qua
	local crafts
	local ys={[-2]=16,[-1]=48,[0]=80,128,160,192,240}
	while pge.running() do
		pge.controls.update()
		if pge.controls.pressed(PGE_CTRL_UP) and inv_y>-2 then
			inv_y=inv_y-1
			if inv_y<1 and inv_x>3 then
				inv_x=3
			end
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) and inv_y<4 then
			inv_y=inv_y+1
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) and inv_x>1 then
			inv_x=inv_x-1
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) and ( (inv_y>0 and inv_x<9 ) or (inv_y<1 and inv_x<3) ) then
			inv_x=inv_x+1
		end
		
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if held then
				local empty=true
				if not inv[inv_x+inv_y*0.1] then
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=last_qua
				else
					if held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
						local qua=last_qua+inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]
						if qua>64 then
							last_qua=qua-64
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=64
							empty=false
						else
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=qua
						end
					else
						local moved=inv[inv_x+inv_y*0.1]
						local moved_qua=inv[moved][inv_x+inv_y*0.1]
						inv[inv_x+inv_y*0.1]=held
						if not inv[held] then
							inv[held]={}
						end
						inv[held][inv_x+inv_y*0.1]=last_qua
						held=moved
						last_qua=moved_qua
						empty=false
					end
				end
				if empty then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1]  then
				held=inv[inv_x+inv_y*0.1]
				inv[inv_x+inv_y*0.1]=nil
				last_qua=inv[held][inv_x+inv_y*0.1]
				inv[held][inv_x+inv_y*0.1]=nil
				if is_empty(inv[held]) then
					inv[held]=nil
				end
			end
			craft=false
		end
		if pge.controls.pressed(PGE_CTRL_SQUARE) then
			if held then
				if not inv[inv_x+inv_y*0.1] then
					last_qua=last_qua-1
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=1
				elseif held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
					last_qua=last_qua-1
					inv[held][inv_x+inv_y*0.1]=inv[held][inv_x+inv_y*0.1]+1
				end
				if last_qua==0 then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1] then
				held=inv[inv_x+inv_y*0.1]
				local qua=inv[held][inv_x+inv_y*0.1]
				if qua==1 then
					last_qua=1
					inv[inv_x+inv_y*0.1]=nil
					inv[held][inv_x+inv_y*0.1]=nil
					if is_empty(inv[held]) then
						inv[held]=nil
					end
				else
					local hqua=pge.math.round(qua/2)
					inv[held][inv_x+inv_y*0.1]=hqua
					last_qua=qua-hqua
				end
			end
			craft=false
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) or pge.controls.pressed(PGE_CTRL_SELECT) then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			if held then
				for t=1,last_qua do
					table.insert(mov_obs,x+238)
					table.insert(mov_obs,y+112)
					table.insert(mov_obs,rander())
					table.insert(mov_obs,pge.math.randfloat(-1,0))
					table.insert(mov_obs,held)
				end
			end
			local slots={0.8,1.8,2.8,0.9,1.9,2.9,1,2,3}
			for t=1,9 do
				if inv[slots[t]] then
					for t2=1,inv[inv[slots[t]]][slots[t]] do
						table.insert(mov_obs,x+238)
						table.insert(mov_obs,y+112)
						table.insert(mov_obs,rander())
						table.insert(mov_obs,pge.math.randfloat(-1,0))
						table.insert(mov_obs,inv[slots[t]])
					end
					inv[inv[slots[t]]][slots[t]]=nil
					if is_empty(inv[inv[slots[t]]]) then
						inv[inv[slots[t]]]=nil
					end
					inv[slots[t]]=nil
				end
			end
			break
		end
		if pge.controls.pressed(PGE_CTRL_TRIANGLE) and inv[inv_x+inv_y*0.1] then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			
			for t=1,inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1] do
				table.insert(mov_obs,x+238)
				table.insert(mov_obs,y+112)
				table.insert(mov_obs,rander())
				table.insert(mov_obs,pge.math.randfloat(-1,0))
				table.insert(mov_obs,inv[inv_x+inv_y*0.1])
			end
			inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=nil
			if is_empty(inv[inv[inv_x+inv_y*0.1]]) then
				inv[inv[inv_x+inv_y*0.1]]=nil
			end
			inv[inv_x+inv_y*0.1]=nil
		end
		if craft and ((pge.controls.pressed(PGE_CTRL_LTRIGGER) and ( not held or (held==craft and (last_qua+crafts<=64)) ) ) or (pge.controls.pressed(PGE_CTRL_RTRIGGER) and not held)) then
			held=craft
			if not last_qua then
				last_qua=0
			end
			local slots={0.8,1.8,2.8,0.9,1.9,2.9,1,2,3}
			if pge.controls.held(PGE_CTRL_LTRIGGER) then
				for t=1,9 do
					if inv[slots[t]] then
						inv[inv[slots[t]]][slots[t]]=inv[inv[slots[t]]][slots[t]]-1
						if inv[inv[slots[t]]][slots[t]]==0 then
							inv[inv[slots[t]]][slots[t]]=nil
							if is_empty(inv[inv[slots[t]]]) then
								inv[slots[t]]=nil
							end
							inv[slots[t]]=nil
						end
					end
				end
				last_qua=last_qua+crafts
			else
				for t=1,9 do
					if inv[slots[t]] then
						inv[inv[slots[t]]][slots[t]]=inv[inv[slots[t]]][slots[t]]-craft_qua/crafts
						if inv[inv[slots[t]]][slots[t]]==0 then
							inv[inv[slots[t]]][slots[t]]=nil
							if is_empty(inv[inv[slots[t]]]) then
								inv[slots[t]]=nil
							end
							inv[slots[t]]=nil
						end
					end
				end
				last_qua=craft_qua
			end
			craft=false
		end
		
		if craft==false then
			craft=nil
			craft_qua=nil
			crafts=nil
			local tbl={}
			local quas={}
			local pos={0.8,1.8,2.8,0.9,1.9,2.9,1,2,3}
			for t=1,9 do
				if inv[pos[t]] then
					tbl[t]=inv[pos[t]]
					quas[t]=inv[tbl[t]][pos[t]]
				end
			end
			
			for t=1,2 do
				if not (tbl[1] or tbl[2] or tbl[3] ) then
					for t=1,3 do
						tbl[t]=tbl[t+3]
						tbl[t+3]=nil
						quas[t]=quas[t+3]
						quas[t+3]=nil
					end
				end
				if not (tbl[4] or tbl[5] or tbl[6] ) then
					for t=4,6 do
						tbl[t]=tbl[t+3]
						tbl[t+3]=nil
						quas[t]=quas[t+3]
						quas[t+3]=nil
					end
				end
				if not (tbl[1] or tbl[4] or tbl[7] ) then
					for t=1,7,3 do
						tbl[t]=tbl[t+1]
						tbl[t+1]=nil
						quas[t]=quas[t+1]
						quas[t+1]=nil
					end
				end
				if not (tbl[2] or tbl[5] or tbl[8] ) then
					for t=2,8,3 do
						tbl[t]=tbl[t+1]
						tbl[t+1]=nil
						quas[t]=quas[t+1]
						quas[t+1]=nil
					end
				end
			end
			
			local line=""
			for t=1,9 do
				if tbl[t] then
					line=line..tbl[t]
				else
					line=line.." "
				end
			end
			
			for i,v in pairs(crafting) do
				if line==i then
					craft=char(v,2)
					local min={}
					for t=1,9 do
						if char(i,t)~=" " then
							table.insert(min,quas[t])
						end
					end
					crafts=tonumber(char(v,1))
					craft_qua=math.min(unpack(min))*crafts
					if craft_qua>64 then
						craft_qua=crafts
						while craft_qua<65 do
							craft_qua=craft_qua+crafts
						end
						craft_qua=craft_qua-crafts
					end
				end
			end
		end
		
		pge.gfx.startdrawing()
		
		pge.texture.activate(pix["inv_slot"])
		for t=1,4 do
			for t2=1,9 do
				pge.texture.draweasy(pix["inv_slot"],64+t2*32,ys[t])
			end
		end
		for t=-2,0 do
			for t2=1,3 do
				pge.texture.draweasy(pix["inv_slot"],64+t2*32,ys[t])
			end
		end
		pge.texture.draweasy(pix["inv_slot"],208,48)
		
		for t=1,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.texture.activate(pix[inv[t2+t*0.1]])
					pge.texture.draw(pix[inv[t2+t*0.1]],68+t2*32,4+ys[t],24,24)
				end
			end
		end
		for t=-2,0 do
			for t2=1,3 do
				if inv[t2+t*0.1] then
					pge.texture.activate(pix[inv[t2+t*0.1]])
					pge.texture.draw(pix[inv[t2+t*0.1]],68+t2*32,4+ys[t],24,24)
				end
			end
		end
		
		if craft then
			pge.texture.activate(pix[craft])
			pge.texture.draw(pix[craft],212,52,24,24)
		end
		
		pge.texture.activate(pix["inv_sel"])
		pge.texture.draweasy(pix["inv_sel"],64+inv_x*32,ys[inv_y])
		
		sin=sin+0.03
		if held then
			pge.texture.activate(pix[held])
			pge.texture.draw(pix[held],68+inv_x*32+math.sin(sin)*18,4+ys[inv_y]+math.cos(sin)*18,24,24,0,0,pix[held]:width(),pix[held]:width(),math.sin(sin)*2)
		end
		
		pge.font.activate(font_2)
		local col=math.abs(math.sin(sin)*255)
		col=pge.gfx.createcolor(col,col,col)
		if held then
			pge.font.print(font_2,73+inv_x*32,16+ys[inv_y],col,last_qua)
		end
		for t=1,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.font.print(font_2,73+t2*32,16+ys[t],col,inv[inv[t2+t*0.1]][t2+t*0.1])
				end
			end
		end
		for t=-2,0 do
			for t2=1,3 do
				if inv[t2+t*0.1] then
					pge.font.print(font_2,73+t2*32,16+ys[t],col,inv[inv[t2+t*0.1]][t2+t*0.1])
				end
			end
		end
		if craft then
			pge.font.print(font_2,217,64,col,craft_qua)
			pge.font.activate(font_1)
			pge.font.print(font_1,257,30,yellow,"Press L To Craft 1")
			pge.font.print(font_1,257,50,yellow,"Press R To Craft Many")
		end
		
		pge.gfx.enddrawing()
		pge.gfx.swapbuffers()
	end
end

function funq_placed.K(f_x,f_y)
	flag_set(flags,f_x,f_y,string.rep(" ",54))
end

function funq_use.K(f_x,f_y)
	local stuff=flag_get(flags,f_x,f_y)
	local slots={}
	for t=1,9 do
		for t2=-2,0 do
			table.insert(slots,t+t2*0.1)
		end
	end
	for t=1,27 do
		if char(stuff,t)~=" " then
			inv[slots[t]]=char(stuff,t)
			if not inv[char(stuff,t)] then
				inv[char(stuff,t)]={}
			end
			inv[char(stuff,t)][slots[t]]=string.byte(char(stuff,t+27))
		end
	end
	
	local last_qua
	local held
	local sin=0
	local ys={[-2]=16,[-1]=48,[0]=80,128,160,192,240}
	while pge.running() do
		pge.controls.update()
		if pge.controls.pressed(PGE_CTRL_UP) and inv_y>-2 then
			inv_y=inv_y-1
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) and inv_y<4 then
			inv_y=inv_y+1
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) and inv_x>1 then
			inv_x=inv_x-1
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) and inv_x<9 then
			inv_x=inv_x+1
		end
		
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if held then
				local empty=true
				if not inv[inv_x+inv_y*0.1] then
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=last_qua
				else
					if held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
						local qua=last_qua+inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]
						if qua>64 then
							last_qua=qua-64
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=64
							empty=false
						else
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=qua
						end
					else
						local moved=inv[inv_x+inv_y*0.1]
						local moved_qua=inv[moved][inv_x+inv_y*0.1]
						inv[inv_x+inv_y*0.1]=held
						if not inv[held] then
							inv[held]={}
						end
						inv[held][inv_x+inv_y*0.1]=last_qua
						held=moved
						last_qua=moved_qua
						empty=false
					end
				end
				if empty then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1]  then
				held=inv[inv_x+inv_y*0.1]
				inv[inv_x+inv_y*0.1]=nil
				last_qua=inv[held][inv_x+inv_y*0.1]
				inv[held][inv_x+inv_y*0.1]=nil
				if is_empty(inv[held]) then
					inv[held]=nil
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_SQUARE) then
			if held then
				if not inv[inv_x+inv_y*0.1] then
					last_qua=last_qua-1
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=1
				elseif held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
					last_qua=last_qua-1
					inv[held][inv_x+inv_y*0.1]=inv[held][inv_x+inv_y*0.1]+1
				end
				if last_qua==0 then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1] then
				held=inv[inv_x+inv_y*0.1]
				local qua=inv[held][inv_x+inv_y*0.1]
				if qua==1 then
					last_qua=1
					inv[inv_x+inv_y*0.1]=nil
					inv[held][inv_x+inv_y*0.1]=nil
					if is_empty(inv[held]) then
						inv[held]=nil
					end
				else
					local hqua=pge.math.round(qua/2)
					inv[held][inv_x+inv_y*0.1]=hqua
					last_qua=qua-hqua
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) or pge.controls.pressed(PGE_CTRL_SELECT) then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			if held then
				for t=1,last_qua do
					table.insert(mov_obs,x+238)
					table.insert(mov_obs,y+112)
					table.insert(mov_obs,rander())
					table.insert(mov_obs,pge.math.randfloat(-1,0))
					table.insert(mov_obs,held)
				end
			end
			break
		end
		if pge.controls.pressed(PGE_CTRL_TRIANGLE) and inv[inv_x+inv_y*0.1] then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			
			for t=1,inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1] do
				table.insert(mov_obs,x+238)
				table.insert(mov_obs,y+112)
				table.insert(mov_obs,rander())
				table.insert(mov_obs,pge.math.randfloat(-1,0))
				table.insert(mov_obs,inv[inv_x+inv_y*0.1])
			end
			inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=nil
			if is_empty(inv[inv[inv_x+inv_y*0.1]]) then
				inv[inv[inv_x+inv_y*0.1]]=nil
			end
			inv[inv_x+inv_y*0.1]=nil
		end
		
		pge.gfx.startdrawing()
		
		pge.texture.activate(pix["inv_slot"])
		for t=-2,4 do
			for t2=1,9 do
				pge.texture.draweasy(pix["inv_slot"],64+t2*32,ys[t])
			end
		end
		
		for t=-2,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.texture.activate(pix[inv[t2+t*0.1]])
					pge.texture.draw(pix[inv[t2+t*0.1]],68+t2*32,4+ys[t],24,24)
				end
			end
		end
		
		pge.texture.activate(pix["inv_sel"])
		pge.texture.draweasy(pix["inv_sel"],64+inv_x*32,ys[inv_y])
		
		sin=sin+0.03
		if held then
			pge.texture.activate(pix[held])
			pge.texture.draw(pix[held],68+inv_x*32+math.sin(sin)*18,4+ys[inv_y]+math.cos(sin)*18,24,24,0,0,pix[held]:width(),pix[held]:width(),math.sin(sin)*2)
		end
		
		pge.font.activate(font_2)
		local col=math.abs(math.sin(sin)*255)
		col=pge.gfx.createcolor(col,col,col)
		if held then
			pge.font.print(font_2,73+inv_x*32,16+ys[inv_y],col,last_qua)
		end
		for t=-2,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.font.print(font_2,73+t2*32,16+ys[t],col,inv[inv[t2+t*0.1]][t2+t*0.1])
				end
			end
		end
		
		pge.gfx.enddrawing()
		pge.gfx.swapbuffers()
	end
	
	local line=""
	for t=1,9 do
		for t2=-2,0 do
			if inv[t+t2*0.1] then
				line=line..inv[t+t2*0.1]
			else
				line=line.." "
			end
		end
	end
	for t=1,9 do
		for t2=-2,0 do
			if inv[t+t2*0.1] then
				line=line..i(inv[inv[t+t2*0.1]][t+t2*0.1])
				inv[inv[t+t2*0.1]][t+t2*0.1]=nil
				if is_empty(inv[inv[t+t2*0.1]]) then
					inv[inv[t+t2*0.1]]=nil
				end
				inv[t+t2*0.1]=nil
			else
				line=line.." "
			end
		end
	end
	
	flag_set(flags,f_x,f_y,line)
end

function funq_break.K(f_x,f_y)
	local items=flag_get(flags,f_x,f_y)
	for t=1,27 do
		if char(items,t)~=" " then
			for t2=1,string.byte(char(items,t+27)) do
				table.insert(mov_obs,f_x*48+24)
				table.insert(mov_obs,f_y*48+24)
				table.insert(mov_obs,pge.math.randfloat(-1,1))
				table.insert(mov_obs,pge.math.randfloat(0.8,1.2))
				table.insert(mov_obs,char(items,t))
			end
		end
	end
end

function funq_placed.O(f_x,f_y)
	flag_set(flags,f_x,f_y,string.rep(" ",6))
end

function funq_use.O(f_x,f_y)
	if inv_y<1 then
		inv_y=1
	end
	
	local smelt
	local smelt_qua
	local line=flag_get(flags,f_x,f_y)
	if char(line,1)~=" " then
		inv[0.9]=char(line,1)
		if not inv[char(line,1)] then
			inv[char(line,1)]={}
		end
		inv[char(line,1)][0.9]=string.byte(char(line,2))
	end
	if char(line,3)~=" " then
		inv[1]=char(line,3)
		if not inv[char(line,3)] then
			inv[char(line,3)]={}
		end
		inv[char(line,3)][1]=string.byte(char(line,4))
	end
	if char(line,5)~=" " then
		smelt=char(line,5)
		smelt_qua=string.byte(char(line,6))
	end
	
	local smelt_per=""
	if furnaces and flag_get(furnaces,f_x,f_y) then
		smelt_per="About "..(flag_get(furnaces,f_x,f_y)*8+8).." Seconds Left"
	end
	
	local last_qua
	local held
	local sin=0
	local ys={[-1]=40,[0]=80,128,160,192,240}
	while pge.running() do
		pge.controls.update()
		if pge.controls.pressed(PGE_CTRL_UP) and inv_y>-1 then
			inv_y=inv_y-1
			if inv_y<1 then inv_x=1 end
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) and inv_y<4 then
			inv_y=inv_y+1
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) and inv_x>1 then
			inv_x=inv_x-1
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) and inv_x<9 then
			inv_x=inv_x+1
			if inv_y<1 then inv_x=1 end
		end
		
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if held then
				local empty=true
				if not inv[inv_x+inv_y*0.1] then
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=last_qua
				else
					if held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
						local qua=last_qua+inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]
						if qua>64 then
							last_qua=qua-64
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=64
							empty=false
						else
							inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=qua
						end
					else
						local moved=inv[inv_x+inv_y*0.1]
						local moved_qua=inv[moved][inv_x+inv_y*0.1]
						inv[inv_x+inv_y*0.1]=held
						if not inv[held] then
							inv[held]={}
						end
						inv[held][inv_x+inv_y*0.1]=last_qua
						held=moved
						last_qua=moved_qua
						empty=false
					end
				end
				if empty then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1]  then
				held=inv[inv_x+inv_y*0.1]
				inv[inv_x+inv_y*0.1]=nil
				last_qua=inv[held][inv_x+inv_y*0.1]
				inv[held][inv_x+inv_y*0.1]=nil
				if is_empty(inv[held]) then
					inv[held]=nil
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_SQUARE) then
			if held then
				if not inv[inv_x+inv_y*0.1] then
					last_qua=last_qua-1
					inv[inv_x+inv_y*0.1]=held
					if not inv[held] then
						inv[held]={}
					end
					inv[held][inv_x+inv_y*0.1]=1
				elseif held==inv[inv_x+inv_y*0.1] and inv[held][inv_x+inv_y*0.1]<64 then
					last_qua=last_qua-1
					inv[held][inv_x+inv_y*0.1]=inv[held][inv_x+inv_y*0.1]+1
				end
				if last_qua==0 then
					held=nil
					last_qua=nil
				end
			elseif inv[inv_x+inv_y*0.1] then
				held=inv[inv_x+inv_y*0.1]
				local qua=inv[held][inv_x+inv_y*0.1]
				if qua==1 then
					last_qua=1
					inv[inv_x+inv_y*0.1]=nil
					inv[held][inv_x+inv_y*0.1]=nil
					if is_empty(inv[held]) then
						inv[held]=nil
					end
				else
					local hqua=pge.math.round(qua/2)
					inv[held][inv_x+inv_y*0.1]=hqua
					last_qua=qua-hqua
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) or pge.controls.pressed(PGE_CTRL_SELECT) then
			if held then
				local rander
				if side then
					rander=loadstring("return pge.math.randfloat(0.5,1)")
				else
					rander=loadstring("return pge.math.randfloat(-1,-0.5)")
				end
				for t=1,last_qua do
					table.insert(mov_obs,x+238)
					table.insert(mov_obs,y+112)
					table.insert(mov_obs,rander())
					table.insert(mov_obs,pge.math.randfloat(-1,0))
					table.insert(mov_obs,held)
				end
			end
			break
		end
		if pge.controls.pressed(PGE_CTRL_TRIANGLE) and inv[inv_x+inv_y*0.1] then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			
			for t=1,inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1] do
				table.insert(mov_obs,x+238)
				table.insert(mov_obs,y+112)
				table.insert(mov_obs,rander())
				table.insert(mov_obs,pge.math.randfloat(-1,0))
				table.insert(mov_obs,inv[inv_x+inv_y*0.1])
			end
			inv[inv[inv_x+inv_y*0.1]][inv_x+inv_y*0.1]=nil
			if is_empty(inv[inv[inv_x+inv_y*0.1]]) then
				inv[inv[inv_x+inv_y*0.1]]=nil
			end
			inv[inv_x+inv_y*0.1]=nil
		end
		if smelt and (pge.controls.pressed(PGE_CTRL_LTRIGGER) and (not held or (held==smelt and last_qua<64))) or (pge.controls.pressed(PGE_CTRL_RTRIGGER) and not held) then
			if pge.controls.held(PGE_CTRL_LTRIGGER) then
				if not held then
					held=smelt
					last_qua=0
				end
				last_qua=last_qua+1
				smelt_qua=smelt_qua-1
				if smelt_qua==0 then
					smelt=nil
					smelt_qua=nil
				end
			else
				held=smelt
				last_qua=smelt_qua
				smelt_qua=nil
				smelt=nil
			end
		end
		
		pge.gfx.startdrawing()
		
		pge.texture.activate(pix["inv_slot"])
		for t=1,4 do
			for t2=1,9 do
				pge.texture.draweasy(pix["inv_slot"],64+t2*32,ys[t])
			end
		end
		pge.texture.draweasy(pix["inv_slot"],96,40)
		pge.texture.draweasy(pix["inv_slot"],96,80)
		pge.texture.draweasy(pix["inv_slot"],144,60)
		
		for t=1,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.texture.activate(pix[inv[t2+t*0.1]])
					pge.texture.draw(pix[inv[t2+t*0.1]],68+t2*32,4+ys[t],24,24)
				end
			end
		end
		for t=-1,0 do
			if inv[1+t*0.1] then
				pge.texture.activate(pix[inv[1+t*0.1]])
				pge.texture.draw(pix[inv[1+t*0.1]],100,4+ys[t],24,24)
			end
		end
		if smelt then
			pge.texture.activate(pix[smelt])
			pge.texture.draw(pix[smelt],148,64,24,24)
		end
		
		pge.texture.activate(pix["inv_sel"])
		pge.texture.draweasy(pix["inv_sel"],64+inv_x*32,ys[inv_y])
		
		sin=sin+0.03
		if held then
			pge.texture.activate(pix[held])
			pge.texture.draw(pix[held],68+inv_x*32+math.sin(sin)*18,4+ys[inv_y]+math.cos(sin)*18,24,24,0,0,pix[held]:width(),pix[held]:width(),math.sin(sin)*2)
		end
		
		pge.font.activate(font_2)
		local col=math.abs(math.sin(sin)*255)
		col=pge.gfx.createcolor(col,col,col)
		if held then
			pge.font.print(font_2,73+inv_x*32,16+ys[inv_y],col,last_qua)
		end
		for t=1,4 do
			for t2=1,9 do
				if inv[t2+t*0.1] then
					pge.font.print(font_2,73+t2*32,16+ys[t],col,inv[inv[t2+t*0.1]][t2+t*0.1])
				end
			end
		end
		for t=-1,0 do
			if inv[1+t*0.1] then
				pge.font.print(font_2,105,16+ys[t],col,inv[inv[1+t*0.1]][1+t*0.1])
			end
		end
		if smelt then
			pge.font.print(font_2,151,69,col,smelt_qua)
			pge.font.activate(font_1)
			pge.font.print(font_1,193,30,yellow,"Press L To Take 1")
			pge.font.print(font_1,193,50,yellow,"Press R To Take All")
			pge.font.print(font_1,193,90,orange,smelt_per)
		else
			pge.font.activate(font_1)
			pge.font.print(font_1,193,90,orange,smelt_per)
		end
		
		pge.gfx.enddrawing()
		pge.gfx.swapbuffers()
	end
	
	if (inv[1]=="j" or inv[1]=="u" or inv[1]=="v" or inv[1]=="w" or inv[1]=="m") and smelting[inv[0.9]] and (not smelt or (smelt==smelting[inv[0.9]] and (smelt_qua+smelting["Q"..inv[0.9]])<=64)) then
		if not funq_10.furnace then
			funq_10.furnace=furnace
			furnaces={}
		end
		if at_pos_r(f_x,f_y)=="O" then
			flag_set(furnaces,f_x,f_y,smelting["T"..inv[0.9]])
			place(f_x,f_y,"q")
		end
	elseif furnaces and flag_get(furnaces,f_x,f_y) then
		if at_pos_r(f_x,f_y)=="q" then
			flag_kill(furnaces,f_x,f_y)
			place(f_x,f_y,"O")
		end
		if is_empty(furnaces) then
			funq_10.furnace=nil
			furnaces=nil
		end
	end
	
	local line=""
	if inv[0.9] then
		line=line..inv[0.9]
		line=line..i(inv[inv[0.9]][0.9])
		inv[inv[0.9]][0.9]=nil
		if is_empty(inv[inv[0.9]]) then
			inv[inv[0.9]]=nil
		end
		inv[0.9]=nil
	else
		line=line.."  "
	end
	if inv[1] then
		line=line..inv[1]
		line=line..i(inv[inv[1]][1])
		inv[inv[1]][1]=nil
		if is_empty(inv[inv[1]]) then
			inv[inv[1]]=nil
		end
		inv[1]=nil
	else
		line=line.."  "
	end
	if smelt then
		line=line..smelt
		line=line..i(smelt_qua)
	else
		line=line.."  "
	end
	
	flag_set(flags,f_x,f_y,line)
end
function funq_use.q(f_x,f_y)
	funq_use.O(f_x,f_y)
end

function furnace()
	for x,tbl in pairs(furnaces) do
		for y,v in pairs(tbl) do
			if v>0 then
				flag_set(furnaces,x,y,v-1)
			else
				local line=flag_get(flags,x,y)
				local raw=char(line,1)
				local raw_num=string.byte(char(line,2))-1
				local coal=char(line,3)
				local coal_num=string.byte(char(line,4))-1
				local smelt=char(line,5)
				local smelt_num=string.byte(char(line,6))+smelting["Q"..raw]
				if smelt==" " then
					smelt=smelting[raw]
					smelt_num=smelting["Q"..raw]
				end
				if raw_num==0 or coal_num==0 or (smelt_num+smelting["Q"..raw])>=64 then
					flag_kill(furnaces,x,y)
					place(x,y,"O")
					if is_empty(furnaces) then
						funq_10.furnace=nil
						furnaces=nil
					end
				else
					flag_set(furnaces,x,y,smelting["T"..smelt])
				end
				if raw_num==0 then
					raw=" "
					raw_num=32
				end
				if coal_num==0 then
					coal=" "
					coal_num=32
				end
				
				flag_set(flags,x,y,raw..i(raw_num)..coal..i(coal_num)..smelt..i(smelt_num))
			end
		end
	end
end

function funq_break.O(f_x,f_y)
	local line=flag_get(flags,f_x,f_y)
	local tbl={}
	for t=1,5,2 do
		if char(line,t)~=" " then
			tbl[char(line,t)]=string.byte(char(line,t+1))
		end
	end
	for i,v in pairs(tbl) do
		for t=1,v do
			table.insert(mov_obs,f_x*48+24)
			table.insert(mov_obs,f_y*48+24)
			table.insert(mov_obs,pge.math.randfloat(-1,1))
			table.insert(mov_obs,pge.math.randfloat(0.8,1.2))
			table.insert(mov_obs,i)
		end
	end
end
function funq_break.q(f_x,f_y)
	funq_break.O(f_x,f_y)
end

function funq_break.l(f_x,f_y)
	if math.random(4)==1 then
		local dirs={{-1,0},{1,0},{0,1},{-1,1},{1,1}}
		local pass=false
		for t=1,5 do
			for mult=1,6 do
				local pos=at_pos_r(f_x+dirs[t][1]*mult,f_y+dirs[t][2]*mult)
				if pos=="u" then
					pass=i(254)
				end
				if pos=="w" then
					pass=i(253)
				end
				if pos=="m" then
					pass=i(252)
				end
				if pos~="l" and pos~="L" and not pass then
					break
				end
				if pass then
					table.insert(mov_obs,f_x*48+24)
					table.insert(mov_obs,f_y*48+24)
					table.insert(mov_obs,pge.math.randfloat(-1,1))
					table.insert(mov_obs,pge.math.randfloat(0.8,1.2))
					table.insert(mov_obs,pass)
					break
				end
			end
			if pass then
				break
			end
		end
	end
end
funq_break.L=funq_break.l

function funq_break.S(f_x,f_y)
	table.insert(mov_obs,f_x*48+24)
	table.insert(mov_obs,f_y*48+24)
	table.insert(mov_obs,pge.math.randfloat(-1,1))
	table.insert(mov_obs,pge.math.randfloat(0.8,1.2))
	if math.random(15)==2 then
		table.insert(mov_obs,i(251))
	else
		table.insert(mov_obs,"S")
	end
end

funq_place[i(248)]=function (f_x,f_y)
	keep=false
	if not funq.snowball then
		function funq.snowball()
			pge.texture.activate(pix[i(248)])
			local rem={}
			for t=4,#snowballs,4 do
				snowballs[t-3]=snowballs[t-3]+snowballs[t-1]*9
				snowballs[t-2]=snowballs[t-2]+snowballs[t]*9
				snowballs[t]=snowballs[t]+0.018
				local hit=at_pos(snowballs[t-3],snowballs[t-2])
				if hit=="V" or hit=="W" then
					local x,y=math.floor(snowballs[t-3]/48),math.floor(snowballs[t-2]/48)
					local dirs={{0,0},{1,0},{-1,0},{0,1},{0,-1}}
					for t=1,5 do
						local hit=at_pos_r(x+dirs[t][1],y+dirs[t][2])
						if hit=="W" or hit=="V" then
							if hit=="W" then
								place(x+dirs[t][1],y+dirs[t][2],"h")
							else
								place(x+dirs[t][1],y+dirs[t][2],"s")
							end
							x=nil
							break
						end
						if not x then
							break
						end
					end
					table.insert(rem,t-3)
				end
				if not block_data[hit][2] then
					table.insert(rem,t-3)
				end
				pge.texture.draweasy(pix[i(248)],snowballs[t-3]-x-12,snowballs[t-2]-y-12)
			end
			for t=#rem,1,-1 do
				for t2=1,4 do
					table.remove(snowballs,rem[t])
				end
			end
			if not snowballs[1] then
				funq.snowball=nil
				snowballs=nil
			end
		end
		snowballs={}
	end
	local dx=-math.sin(hand_ang)
	local dy=math.cos(hand_ang)
	table.insert(snowballs,x+238+dx*32)
	table.insert(snowballs,y+112+dy*32)
	table.insert(snowballs,dx)
	table.insert(snowballs,dy)
	
	inv[i(248)][menu_t+0.4]=inv[i(248)][menu_t+0.4]-1
	if inv[i(248)][menu_t+0.4]==0 then
		inv[menu_t+0.4]=nil
		inv[i(248)][menu_t+0.4]=nil
		if is_empty(inv[i(248)]) then
			inv[i(248)]=nil
		end
	end
end

function funq_placed.y(f_x,f_y)
	flag_set(flags,f_x,f_y,true)
	if not funq_05.vine_grow then
		vine_t=0
		vines={}
		function funq_05.vine_grow()
			vine_t=vine_t+1
			if vine_t==3 then
				vine_t=0
				local updates={}
				for x,tbl in pairs(vines) do
					for y,v in pairs(tbl) do
						if v<6 and game_data[x-1] and game_data[x+1] then
							local p1=at_pos_r(x-1,y-1)
							local p2=at_pos_r(x+1,y-1)
							local p3=at_pos_r(x-1,y+1)
							local p4=at_pos_r(x+1,y+1)
							p1=not is_none(p1) and p1~="y"
							p2=not is_none(p2) and p2~="y"
							p3=not is_none(p3) and p3~="y"
							p4=not is_none(p4) and p4~="y"
							if (p1 or p2) and is_none(at_pos_r(x,y-1)) then
								table.insert(updates,x)
								table.insert(updates,y-1)
								table.insert(updates,v+1)
							end
							if (p2 or p3) and is_none(at_pos_r(x+1,y)) then
								table.insert(updates,x+1)
								table.insert(updates,y)
								table.insert(updates,v+1)
							end
							if (p3 or p4) and is_none(at_pos_r(x,y+1)) then
								table.insert(updates,x)
								table.insert(updates,y+1)
								table.insert(updates,v+1)
							end
							if (p4 or p1) and is_none(at_pos_r(x-1,y)) then
								table.insert(updates,x-1)
								table.insert(updates,y)
								table.insert(updates,v+1)
							end
						end
						flag_kill(vines,x,y)
					end
				end
				for t=3,#updates,3 do
					update_at(updates[t-2],updates[t-1])
					place(updates[t-2],updates[t-1],"y")
					flag_set(vines,updates[t-2],updates[t-1],updates[t])
				end
				if is_empty(vines) then
					funq_05.vine_grow=nil
					vines=nil
					vine_t=nil
				end
			end
		end
	end
	flag_set(vines,f_x,f_y,1)
end

function funq_break.y(f_x,f_y)
	if flag_get(flags,f_x,f_y) then
		table.insert(mov_obs,f_x*48+24)
		table.insert(mov_obs,f_y*48+24)
		table.insert(mov_obs,pge.math.randfloat(-1,1))
		table.insert(mov_obs,pge.math.randfloat(0.8,1.2))
		table.insert(mov_obs,"y")
	end
end

function funq_update.Y(f_x,f_y)
	if not is_none(at_pos_r(f_x-1,f_y)) and is_none(at_pos_r(f_x+1,f_y)) then
		flag_set(flags,f_x,f_y,1)
	elseif is_none(at_pos_r(f_x-1,f_y)) and not is_none(at_pos_r(f_x+1,f_y)) then
		flag_set(flags,f_x,f_y,2)
	else
		flag_kill(flags,f_x,f_y)
	end
end

funq_placed["<"]=function (f_x,f_y)
	pge.utils.oskinit("Index...")
	while pge.running() do
		pge.gfx.startdrawing()
		pge.texture.activate(pix["bg"])	
		pge.texture.draw(pix["bg"],0,0,480,272)
		pge.gfx.enddrawing()
		state,string = pge.utils.oskupdate()
		pge.gfx.swapbuffers()
		if state then
			if string=="" then
				pge.utils.oskinit("Index...")
			else
				flag_set(flags,f_x,f_y,string)
				teles[at_pos_r(f_x,f_y)][string]=f_x..":"..f_y
				break
			end
		end
	end
end
funq_placed[">"]=funq_placed["<"]

funq_break["<"]=function (f_x,f_y)
	teles["<"][flag_get(flags,f_x,f_y)]=nil
end
funq_break[">"]=function (f_x,f_y)
	teles[">"][flag_get(flags,f_x,f_y)]=nil
end

funq_use["<"]=function (f_x,f_y)
	local type="<"
	if at_pos_r(f_x,f_y)=="<" then
		type=">"
	end
	if teles[type][flag_get(flags,f_x,f_y)] then
		local s=teles[type][flag_get(flags,f_x,f_y)]
		local n=string.find(s,":")
		new_x=tonumber(string.sub(s,1,n-1))*48-216
		new_y=tonumber(string.sub(s,n+1))*48-138
		tele_t=0
		function funq.tele_effect()
			pge.gfx.drawcircle(240,131,tele_t,48,orange)
			if new_x then
				tele_t=tele_t+8
				if tele_t==320 then
					x=new_x
					y=new_y
					new_x,new_y=nil,nil
					moved=true
				end
			else
				tele_t=tele_t-8
				if tele_t==0 then
					funq.tele_effect=nil
					tele_t=nil
				end
			end
		end
	else
		err_t=120
		function funq.error_m()
			err_t=err_t-1
			if err_t<0 then
				err_t=nil
				funq.error_m=nil
			else
				pge.font.activate(font_1)
				pge.font.printcenter(font_1,60,pge.gfx.createcolor(255,100,0,err_t*4),"No Target With Same Index")
			end
		end
	end
end
funq_use[">"]=funq_use["<"]

funq_place[i(252)]=function ()
	health=health+13
	if health>96 then
		health=96
	end
	inv[inv[menu_t+0.4]][menu_t+0.4]=inv[inv[menu_t+0.4]][menu_t+0.4]-1
	if inv[inv[menu_t+0.4]][menu_t+0.4]==0 then
		inv[inv[menu_t+0.4]][menu_t+0.4]=nil
		if is_empty(inv[inv[menu_t+0.4]]) then
			inv[inv[menu_t+0.4]]=nil
		end
		inv[menu_t+0.4]=nil
	end
	keep=false
end
funq_place[i(253)]=funq_place[i(252)]
funq_place[i(254)]=funq_place[i(252)]

function funq_touch.V()
	if not funq_05.burn then
		function funq_05.burn()
			if at_pos(x+232,y+88)=="V" or at_pos(x+243,y+88)=="V" or at_pos(x+232,y+183)=="V" or at_pos(x+243,y+183)=="V" then
				dam_t=255
				function funq.dam()
					dam_t=dam_t-26
					if dam_t>0 then
						pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(255,0,0,dam_t))
					else
						dam_t=nil
						funq.dam=nil
					end
				end
				health=health-16
				health_check()
			else
				funq_05.burn=nil
			end
		end
	end
	if not funq.climb then
		function funq.climb()
			local tbl={at_pos(x+232,y+88),at_pos(x+243,y+88),at_pos(x+232,y+183),at_pos(x+243,y+183)}
			local tbl2={"f","y","W","V"}
			local pass
			for t=1,4 do
				for t2=1,4 do
					if tbl2[t]==tbl[t2] then
						pass=true
						break
					end
				end
				if pass then
					break
				end
			end
			if pass then
				if m_jump() then
					jump_speed=3
				end
				fall_speed=4
			else
				funq.climb=nil
			end
		end
	end
end
funq_touch["6"] = function()
	if not funq_05.sting then
		function funq_05.sting()
			if at_pos(x+243,y+184)=="6" or at_pos(x+232,y+184)=="6" then
				dam_t=255
				function funq.dam()
					dam_t=dam_t-26
					if dam_t>0 then
						pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(255,0,0,dam_t))
					else
						dam_t=nil
						funq.dam=nil
					end
				end
				health=health-8
				health_check()
			else
				local s=""
				for t=3,6 do
					s=s..string.sub(game_data[t],floor_y+1,floor_y+4)
				end
				if not string.find(s,"6") then
					funq_05.sting=nil
				end
			end
		end
	end
end

tool_blocks={{"d","S","R","g","n","o"},{"u","v","w","m","y"},{"s","c","i","a","e","A","r","G","D","","k","t"}}
tool_power={0.50,0.36,0.27,0.16,0.1}
tool_health={}
local tbl={30,100,150,180,270}
local t3=0
for t=226,236,5 do
	t3=t3+1
	for t2=0,4 do
		tool_health[i(t+t2)]=tbl[1+t2]
		funq_hit[i(t+t2)] = function ()
			local n=string.byte(inv[menu_t+0.4])
			local tool=math.abs(math.floor((225-n)/5))
			local mat=5-(math.ceil(n/5)*5-n)
			for t=1,#tool_blocks[tool] do
				if sel==tool_blocks[tool][t] then
					block_health=block_health*tool_power[mat]
					t_block_health=block_health
					break
				end
			end
		end
	end
end
weapons={[i(216)]=24,[i(217)]=48,[i(218)]=64,[i(219)]=85,[i(220)]=100} --default attack power is 9
weapon_health={[i(216)]=15,[i(217)]=35,[i(218)]=50,[i(219)]=70,[i(220)]=90}

function funq_screen.Y(f_x,f_y)
	flag_set(light,f_x,f_y,true)
end
funq_screen.V=funq_screen.Y
funq_place.Y=funq_screen.Y
function funq_break.Y(f_x,f_y)
	flag_kill(light,f_x,f_y)
end

funq_place[i(225)]=function(f_x,f_y)
	if at_pos_r(f_x,f_y)=="W" or at_pos_r(f_x,f_y)=="V" then
		local new=i(224)
		if at_pos_r(f_x,f_y)=="V" then
			new=i(223)
		end
		
		inv[i(225)][menu_t+0.4]=inv[i(225)][menu_t+0.4]-1
		if inv[i(225)][menu_t+0.4]==0 then
			inv[i(225)][menu_t+0.4]=nil
			if is_empty(inv[i(225)]) then
				inv[i(225)]=nil
			end
			inv[menu_t+0.4]=nil
		end
		
		local pass=false
		if inv[new] then
			for i,v in pairs(inv[new]) do
				if v<64 then
					inv[new][i]=inv[new][i]+1
					pass=true
				end
			end
		end
		if not pass then
			for t=1,9 do
				for t2=4,1,-1 do
					if not inv[t+t2*0.1] then
						inv[t+t2*0.1]=new
						if not inv[new] then
							inv[new]={}
						end
						inv[new][t+t2*0.1]=1
						pass=true
						break
					end
				end
				if pass then
					break
				end
			end
		end
		if not pass then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			table.insert(mov_obs,x+238)
			table.insert(mov_obs,y+112)
			table.insert(mov_obs,rander())
			table.insert(mov_obs,pge.math.randfloat(-1,0))
			table.insert(mov_obs,new)
		end
		
		place(f_x,f_y," ")
		update_at(f_x,f_y)
	end
	keep=false
end

funq_place[i(224)]=function(f_x,f_y)
	if is_none(at_pos_r(f_x,f_y)) then
		
		inv[i(224)][menu_t+0.4]=inv[i(224)][menu_t+0.4]-1
		if inv[i(224)][menu_t+0.4]==0 then
			inv[i(224)][menu_t+0.4]=nil
			if is_empty(inv[i(224)]) then
				inv[i(224)]=nil
			end
			inv[menu_t+0.4]=nil
		end
		
		local pass=false
		if inv[i(225)] then
			for ind,v in pairs(inv[i(225)]) do
				if v<64 then
					inv[i(225)][ind]=inv[i(225)][ind]+1
					pass=true
				end
			end
		end
		if not pass then
			for t=1,9 do
				for t2=4,1,-1 do
					if not inv[t+t2*0.1] then
						inv[t+t2*0.1]=i(225)
						if not inv[i(225)] then
							inv[i(225)]={}
						end
						inv[i(225)][t+t2*0.1]=1
						pass=true
						break
					end
				end
				if pass then
					break
				end
			end
		end
		if not pass then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			table.insert(mov_obs,x+238)
			table.insert(mov_obs,y+112)
			table.insert(mov_obs,rander())
			table.insert(mov_obs,pge.math.randfloat(-1,0))
			table.insert(mov_obs,i(225))
		end
		
		place(f_x,f_y,"W")
		update_at(f_x,f_y)
	end
	keep=false
end

funq_place[i(223)]=function(f_x,f_y)
	if is_none(at_pos_r(f_x,f_y)) then
		
		inv[i(223)][menu_t+0.4]=inv[i(223)][menu_t+0.4]-1
		if inv[i(223)][menu_t+0.4]==0 then
			inv[i(223)][menu_t+0.4]=nil
			if is_empty(inv[i(223)]) then
				inv[i(223)]=nil
			end
			inv[menu_t+0.4]=nil
		end
		
		local pass=false
		if inv[i(225)] then
			for ind,v in pairs(inv[i(225)]) do
				if v<64 then
					inv[i(225)][ind]=inv[i(225)][ind]+1
					pass=true
				end
			end
		end
		if not pass then
			for t=1,9 do
				for t2=4,1,-1 do
					if not inv[t+t2*0.1] then
						inv[t+t2*0.1]=i(225)
						if not inv[i(225)] then
							inv[i(225)]={}
						end
						inv[i(225)][t+t2*0.1]=1
						pass=true
						break
					end
				end
				if pass then
					break
				end
			end
		end
		if not pass then
			local rander
			if side then
				rander=loadstring("return pge.math.randfloat(0.5,1)")
			else
				rander=loadstring("return pge.math.randfloat(-1,-0.5)")
			end
			table.insert(mov_obs,x+238)
			table.insert(mov_obs,y+112)
			table.insert(mov_obs,rander())
			table.insert(mov_obs,pge.math.randfloat(-1,0))
			table.insert(mov_obs,i(225))
		end
		
		place(f_x,f_y,"V")
		update_at(f_x,f_y)
	end
	keep=false
end

funq_update["#"]=function(f_x,f_y)
	for t=-2,2 do
		for t2=-2,2 do
			local block=at_pos_r(f_x+t,f_y+t2)
			if block=="W" or block=="V" then
				place(f_x+t,f_y+t2," ")
			end
		end
	end
	if water_flow then
		for t=-3,3 do
			for t2=-3,3 do
				flag_kill(water_flow,f_x+t,f_y+t2)
			end
		end
	end
	if lava_flow then
		for t=-3,3 do
			for t2=-3,3 do
				flag_kill(lava_flow,f_x+t,f_y+t2)
			end
		end
	end
end

funq_break["#"]=function(f_x,f_y)
	for t=-2,2 do
		is_update(f_x+t,f_y-3)
		is_update(f_x+3,f_y+t)
		is_update(f_x-3,f_y+t)
	end
end

funq_place[i(222)]=function()
	health=health+22
	if health>96 then
		health=96
	end
	
	inv[i(222)][menu_t+0.4]=inv[i(222)][menu_t+0.4]-1
	if inv[i(222)][menu_t+0.4]==0 then
		inv[i(222)][menu_t+0.4]=nil
		if is_empty(inv[i(222)]) then
			inv[i(222)]=nil
		end
		inv[menu_t+0.4]=nil
	end
	
	local pass=false
	if inv[i(221)] then
		for ind,v in pairs(inv[i(221)]) do
			if v<64 then
				inv[i(221)][ind]=inv[i(221)][ind]+1
				pass=true
			end
		end
	end
	if not pass then
		for t=1,9 do
			for t2=4,1,-1 do
				if not inv[t+t2*0.1] then
					inv[t+t2*0.1]=i(221)
					if not inv[i(221)] then
						inv[i(221)]={}
					end
					inv[i(221)][t+t2*0.1]=1
					pass=true
					break
				end
			end
			if pass then
				break
			end
		end
	end
	if not pass then
		local rander
		if side then
			rander=loadstring("return pge.math.randfloat(0.5,1)")
		else
			rander=loadstring("return pge.math.randfloat(-1,-0.5)")
		end
		table.insert(mov_obs,x+238)
		table.insert(mov_obs,y+112)
		table.insert(mov_obs,rander())
		table.insert(mov_obs,pge.math.randfloat(-1,0))
		table.insert(mov_obs,i(221))
	end
		
	keep=false
end

function funq_update.o(f_x,f_y)
	if sel=="o" and not is_none(at_pos_r(f_x,f_y-1)) and place_y==-1 then
		place(f_x,f_y,at_pos_r(f_x,f_y-1))
		place(f_x,f_y-1," ")
		flag_set(flags,f_x,f_y,flag_get(flags,f_x,f_y-1))
		flag_kill(flags,f_x,f_y-1)
	end
	if is_none(at_pos_r(f_x,f_y+1)) then
		place(f_x,f_y," ")
	end	
end

funq_placed["!"]=function(f_x,f_y)
	if not funq_10.ghost_gen then
		funq_10.ghost_gen=ghost_gen
		teles.ghost_gens={}
	end
	teles.ghost_gens[f_x..":"..f_y]=true
end

function ghost_gen()
	if is_empty(teles["ghost_gens"]) then
		funq_10.ghost_gen=nil
		teles.ghost_gens=nil
	else
		for t,v in pairs(teles["ghost_gens"]) do
			local p=string.find(t,":")
			local x=tonumber(string.sub(t,1,p-1))
			local y=tonumber(string.sub(t,p+1))
			table.insert(npcs,x*48-24)
			table.insert(npcs,y*48-24)
			table.insert(npcs,{math.random(-4,4),math.random(-4,4),time+math.random(160,320),96})
			table.insert(npcs,"ghost")
		end
	end
end

funq_break["!"]=function(f_x,f_y)
	teles.ghost_gens[f_x..":"..f_y]=nil
end

funq_place[i(215)]=function()
	
	health_pot_t=300
	function funq.health_potion()
		if health~=96 then
			health=96
		end
		pge.gfx.drawcircle(416,256,health_pot_t*16/300,24,pge.gfx.createcolor(0,0,200,160))
		health_pot_t=health_pot_t-0.5
		if health_pot_t<=0 then
			funq.health_potion=nil
		end
	end
	
	inv[i(215)][menu_t+0.4]=inv[i(215)][menu_t+0.4]-1
	if inv[i(215)][menu_t+0.4]==0 then
		inv[i(215)][menu_t+0.4]=nil
		if is_empty(inv[i(215)]) then
			inv[i(215)]=nil
		end
		inv[menu_t+0.4]=nil
	end
	
	local pass=false
	if inv[i(221)] then
		for ind,v in pairs(inv[i(221)]) do
			if v<64 then
				inv[i(221)][ind]=inv[i(221)][ind]+1
				pass=true
			end
		end
	end
	if not pass then
		for t=1,9 do
			for t2=4,1,-1 do
				if not inv[t+t2*0.1] then
					inv[t+t2*0.1]=i(221)
					if not inv[i(221)] then
						inv[i(221)]={}
					end
					inv[i(221)][t+t2*0.1]=1
					pass=true
					break
				end
			end
			if pass then
				break
			end
		end
	end
	if not pass then
		local rander
		if side then
			rander=loadstring("return pge.math.randfloat(0.5,1)")
		else
			rander=loadstring("return pge.math.randfloat(-1,-0.5)")
		end
		table.insert(mov_obs,x+238)
		table.insert(mov_obs,y+112)
		table.insert(mov_obs,rander())
		table.insert(mov_obs,pge.math.randfloat(-1,0))
		table.insert(mov_obs,i(221))
	end
		
	keep=false
end

local dir=pge.file.open("settings.cfg",PGE_FILE_RDONLY)
temp=pge.file.read(dir,pge.file.size(dir))
pge.file.close(dir)
theme=string.sub(temp,16)
cons_file=string.sub(temp,1,15)

pix={}
meta={}
meta.__index = function (tbl,index)
	local v=rawget(tbl,index)
	if v==nil then
		return tbl.missing
	else
		return v
	end
end
setmetatable(pix,meta)

dofile("resources.lua")